<?php
class datediff {
 private $day0,$month0,$year0,$interval,$time0,$date0,
  $r, //r= - 
  //  1 -  --
  //  2 -   
  //  3 -    
  $f, //    
  $days,$monthdays,$monthes,$years,$weeks,$weekdays;
 public
  $time1,$time2,$date1,$date2,
  $day1,$month1,$year1,$day2,$month2,$year2;

 function __construct () {
  @date_default_timezone_set (date_default_timezone_get()); //      date()
  $this->setdate0 ();
  $this->setdate1 (1,1,$this->year0);
  $this->setdate2 ($this->day0,$this->month0,$this->year0);
  $this->interval = $this->date1->diff($this->date2);
  $this->r=7;
  $this->f=13;
 }

 private function setdate0 () {
  $this->day0=date("d");
  $this->month0=date("m");
  $this->year0=date("Y");
  $this->time0 = date ("Y-m-d H:m:s",mktime(0,0,0,$this->month0,$this->day0,$this->year0));
 }

 function setdate1 ($d,$m,$y) {
  $this->day1=$d; $this->month1=$m; $this->year1=$y;
  $this->time1 = date ("Y-m-d H:m:s",mktime (0,0,0,$this->month1,$this->day1,$this->year1));
  $this->date1 = new DateTime($this->time1); 
 }

 function setdate2 ($d,$m,$y) {
  $this->day2=$d; $this->month2=$m; $this->year2=$y;
  $this->time2 = date ("Y-m-d H:m:s",mktime (0,0,0,$this->month2,$this->day2,$this->year2));
  $this->date2 = new DateTime($this->time2);
 }

 function get_word_form ($n,$word,$o1,$o2,$o5) {
  //     $word    $n.
  //:
  //$o1 -    *1, 
  //$o2 -   *2-*4, 
  //$o5 -    *5-*9,*0,*11-*19
  $n=abs($n);
  if ($n%100>10 and $n%100<20 or $n%10==0 or $n%10>4) $word.=$o5;
  else if ($n%10>1 and $n%10<5) $word.=$o2;
  else $word.=$o1;
  return $word;
 }

 function leapyear ($y) { //true,   
  return ($y%4==0) and ($y%100!=0) or ($y%400==0); 
 }

 function get_max_day ($m,$y) {
  $dayscount=array(31,28,31,30,31,30,31,31,30,31,30,31);
  $d=$dayscount[$m-1];
  if ($this->leapyear($y) and $m==2) $d=29;
  return $d;
 }

 function correct_date ($d,$m,$y) {
  if ($m<1 or $m>12 or $y<1 or $y>9999999999) return false;
  $dmax=$this->get_max_day ($m,$y);
  if ($d<1 or $d>$dmax) return false;
  return true;
 }

 function setmode ($mode) { $this->r=$mode; }
 function setfontsize ($size) { if ($size<8) $size=8; else if ($size>72) $size=72; $this->f=$size; }

 function gettext ($hdr='') {
  $this->interval = $this->date1->diff($this->date2);
  $this->days=$this->interval->days;
  if ($this->interval->invert==1) $this->days=-$this->days;
  $this->monthes=$this->interval->m;
  $this->years=$this->interval->y;
  $this->monthdays=$this->interval->d;
  $monthdaysmax=$this->get_max_day($this->month0,$this->year0);
  if ($this->interval->h>12) {
   $this->days=$this->interval->days+1;
   if ($this->monthdays<$monthdaysmax) $this->monthdays++;
   else {
    $this->monthdays=0;
    $this->monthes++;
    if ($this->monthes==12) {
     $this->monthes=0;
     $this->years++;
    }
   }
  }
  if ($this->date1 == $this->date2) return ' ';
  //   diff:
  if ($this->day1<$this->day2 and $this->day2-$this->day1!=$this->monthdays) 
   $this->monthdays=$this->day2-$this->day1; 
  if ($this->day1==$this->day2 and $this->monthdays!=0) {
   if ($this->month1<$this->month2) $this->monthes=$this->month2-$this->month1;
   else if ($this->month1==$this->month2) $this->monthes=0;
   else $this->monthes=(12-$this->month1)+$this->month2;
   $this->monthdays=0;
  }
  // :
  $text='';
  if (!empty($hdr)) $text=$hdr.' ';
  if ($this->r&1) {
   $text.= $this->years<1 ? '' : $this->years.' '.$this->get_word_form($this->years,'','','','');
   if ($this->years>0 and ($this->monthes>0 or $this->monthdays>0)) $text.= ', ';
   $text.= $this->monthes<1 ? '' : $this->monthes.' '.$this->get_word_form($this->monthes,'','','','');
   if ($this->monthes>0 and $this->monthdays>0) $text.= ', ';
   $text.= $this->monthdays<1 ? '' : $this->monthdays.' '.$this->get_word_form($this->monthdays,'','','','');
  }
  if ($this->r&2) {
   if ($this->r&1 and ($this->years>0 or $this->monthes>0 or $this->monthdays>6)) $text.= '; ';
   if ($this->years>0 or $this->monthes>0) $text.= $this->days.' '.$this->get_word_form($this->days,'','','','');
  }
  if ($this->r&4) {
   if (abs($this->days)>6) {
    $this->weeks = floor ($this->days/7);
    $this->weekdays = $this->days - $this->weeks*7;
    if ($this->r&3 and ($this->years>0 or $this->monthes>0)) $text.= ';';
    $text.= ' '.$this->weeks.' '.$this->get_word_form($this->weeks,'','','','');
    if ($this->weekdays>0) $text.= ', '.$this->weekdays.' '.$this->get_word_form($this->weekdays,'','','','');
   }
  }
  //print_r($this->interval);
  return $text;
 }

 private function str_rus ($str){
  $nstr=''; 
  for ($i=0; $i<strlen($str); $i++) {
   $symbol=substr($str,$i,1);
   $ascii=ord($symbol);
   if ($ascii < 128) { $nstr .= $symbol; } 
   elseif ($ascii > 191 and $ascii < 256) { $nstr .= '&#'. (string)(848 + ord($symbol)).';'; } 
   elseif ($ascii == 184) { $nstr .= '&#1105;'; } // 
   elseif ($ascii == 168) { $nstr .= '&#1025;'; } // 
   elseif ($ascii == 150) { $nstr .= '&#45;'; } // 
   else { $nstr .= $symbol; }
  }
  return ($nstr);
 }

 function getimage ($hdr='') {
  if (!extension_loaded('gd')) { echo ' GDLib 2 (gd2) !'; return; }
  $text = $hdr.(empty($hdr)?'':' ').$this->gettext();
  $font = 'comic.ttf';
  $bbox=imagettfbbox ($this->f,0,$font,$this->str_rus($text));
  $wt=abs($bbox[4]-$bbox[6]+1);
  $ht=abs($bbox[5]-$bbox[1]+1);
  $img = imagecreate($wt+4, $ht+4);
  $bg = imagecolorallocate($img, 255, 255, 255); //1-  imagecolorallocate  !
  $textcolor = imagecolorallocate($img, 0, 0, 0);
  imagettftext ($img,$this->f,0,2,$ht,$textcolor,$font,$this->str_rus($text));
  header ('Content-type: image/jpeg'); 
  imagejpeg($img,NULL,90);
  imagedestroy($img);
 }
}
?>